<html>
<head>
<title>Animation - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#define-members">Defines</a> &#124;
<a href="#typedef-members">Typedefs</a> &#124;
<a href="#enum-members">Enumerations</a>  </div>
  <div class="headertitle">
<div class="title">Animation</div>  </div>
<div class="ingroups"><a class="el" href="group__Core.html">Core</a></div></div><!--header-->
<div class="contents">
<div class="dynheader">
Collaboration diagram for Animation:</div>
<div class="dyncontent">
<center><table><tr><td><img src="group__Animation.gif" border="0" alt="" usemap="#group____Animation"/>
<map name="group____Animation" id="group____Animation">
<area shape="rect" id="node1" href="group__Core.html" title="Core" alt="" coords="5,5,56,35"/></map>
</td></tr></table></center>
</div>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimableValue.html">Ogre::AnimableValue</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Defines an object property which is animable, i.e.  <a href="classOgre_1_1AnimableValue.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimableObject.html">Ogre::AnimableObject</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Defines an interface to classes which have one or more <a class="el" href="classOgre_1_1AnimableValue.html" title="Defines an object property which is animable, i.e.">AnimableValue</a> instances to expose.  <a href="classOgre_1_1AnimableObject.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationContainer.html">Ogre::AnimationContainer</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">An animation container interface, which allows generic access to sibling animations.  <a href="classOgre_1_1AnimationContainer.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Animation.html">Ogre::Animation</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">An animation sequence.  <a href="classOgre_1_1Animation.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationState.html">Ogre::AnimationState</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Represents the state of an animation and the weight of its influence.  <a href="classOgre_1_1AnimationState.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationStateSet.html">Ogre::AnimationStateSet</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class encapsulating a set of <a class="el" href="classOgre_1_1AnimationState.html" title="Represents the state of an animation and the weight of its influence.">AnimationState</a> objects.  <a href="classOgre_1_1AnimationStateSet.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationStateControllerValue.html">Ogre::AnimationStateControllerValue</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue</a> wrapper class for <a class="el" href="classOgre_1_1AnimationState.html" title="Represents the state of an animation and the weight of its influence.">AnimationState</a>.  <a href="classOgre_1_1AnimationStateControllerValue.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TimeIndex.html">Ogre::TimeIndex</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Time index object used to search keyframe at the given position.  <a href="classOgre_1_1TimeIndex.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html">Ogre::AnimationTrack</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A 'track' in an animation sequence, i.e.  <a href="classOgre_1_1AnimationTrack.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html">Ogre::NumericAnimationTrack</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Specialised <a class="el" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a> for dealing with generic animable values.  <a href="classOgre_1_1NumericAnimationTrack.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NodeAnimationTrack.html">Ogre::NodeAnimationTrack</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Specialised <a class="el" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a> for dealing with node transforms.  <a href="classOgre_1_1NodeAnimationTrack.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexAnimationTrack.html">Ogre::VertexAnimationTrack</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Specialised <a class="el" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a> for dealing with changing vertex position information.  <a href="classOgre_1_1VertexAnimationTrack.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Bone.html">Ogre::Bone</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A bone in a skeleton.  <a href="classOgre_1_1Bone.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1KeyFrame.html">Ogre::KeyFrame</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A key frame in an animation sequence defined by an <a class="el" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>.  <a href="classOgre_1_1KeyFrame.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericKeyFrame.html">Ogre::NumericKeyFrame</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Specialised <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> which stores any numeric value.  <a href="classOgre_1_1NumericKeyFrame.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TransformKeyFrame.html">Ogre::TransformKeyFrame</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Specialised <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> which stores a full transform.  <a href="classOgre_1_1TransformKeyFrame.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexMorphKeyFrame.html">Ogre::VertexMorphKeyFrame</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Specialised <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> which stores absolute vertex positions for a complete buffer, designed to be interpolated with other keys in the same track.  <a href="classOgre_1_1VertexMorphKeyFrame.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexPoseKeyFrame.html">Ogre::VertexPoseKeyFrame</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Specialised <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> which references a Mesh::Pose at a certain influence level, which stores offsets for a subset of the vertices in a buffer to provide a blendable pose.  <a href="classOgre_1_1VertexPoseKeyFrame.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Pose.html">Ogre::Pose</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A pose is a linked set of vertex offsets applying to one set of vertex data.  <a href="classOgre_1_1Pose.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Skeleton.html">Ogre::Skeleton</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A collection of <a class="el" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a> objects used to animate a skinned mesh.  <a href="classOgre_1_1Skeleton.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SkeletonPtr.html">Ogre::SkeletonPtr</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Specialisation of <a class="el" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a> to allow <a class="el" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a> to be assigned to <a class="el" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a>.  <a href="classOgre_1_1SkeletonPtr.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1LinkedSkeletonAnimationSource.html">Ogre::LinkedSkeletonAnimationSource</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Link to another skeleton to share animations.  <a href="structOgre_1_1LinkedSkeletonAnimationSource.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SkeletonManager.html">Ogre::SkeletonManager</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Handles the management of skeleton resources.  <a href="classOgre_1_1SkeletonManager.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SkeletonSerializer.html">Ogre::SkeletonSerializer</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class for serialising skeleton data to/from an OGRE .skeleton file.  <a href="classOgre_1_1SkeletonSerializer.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TagPoint.html">Ogre::TagPoint</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A tagged point on a skeleton, which can be used to attach entities to on specific other entities.  <a href="classOgre_1_1TagPoint.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1VertexBoneAssignment__s.html">Ogre::VertexBoneAssignment_s</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Records the assignment of a single vertex to a single bone with the corresponding weight.  <a href="structOgre_1_1VertexBoneAssignment__s.html#details">More...</a><br/></td></tr>
<tr><td colspan="2"><h2><a name="define-members"></a>
Defines</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Animation.html#ga4393e2afffe021cb323b896779de3d17">OGRE_MAX_NUM_BONES</a>&#160;&#160;&#160;256</td></tr>
<tr><td colspan="2"><h2><a name="typedef-members"></a>
Typedefs</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef SharedPtr&lt; AnimableValue &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Animation.html#ga5e0882c3b9f7ca32a795f98cf034e428">Ogre::AnimableValuePtr</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef map&lt; String, <br class="typebreak"/>
AnimationState * &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Animation.html#ga2fd1388ea690fecefc6bfe496d13e19f">Ogre::AnimationStateMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef MapIterator<br class="typebreak"/>
&lt; AnimationStateMap &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Animation.html#gac427736c80940f4469fe0f4ac1694f67">Ogre::AnimationStateIterator</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef ConstMapIterator<br class="typebreak"/>
&lt; AnimationStateMap &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Animation.html#gaad9cc8241f80d9d8fb4f112409de792f">Ogre::ConstAnimationStateIterator</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef list&lt; AnimationState * &gt;<br class="typebreak"/>
::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Animation.html#ga7f7651abe4d9e073cfdbcafd79da3511">Ogre::EnabledAnimationStateList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef ConstVectorIterator<br class="typebreak"/>
&lt; EnabledAnimationStateList &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Animation.html#ga7bc761681d8c97c449763d8b77dcedf8">Ogre::ConstEnabledAnimationStateIterator</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef vector&lt; Pose * &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Animation.html#ga2320179c7d0107995d8a737c86a40333">Ogre::PoseList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef struct <br class="typebreak"/>
<a class="el" href="structOgre_1_1VertexBoneAssignment__s.html">Ogre::VertexBoneAssignment_s</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Animation.html#gaf7318ddaeea193a759de6349554ec3a4">Ogre::VertexBoneAssignment</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Records the assignment of a single vertex to a single bone with the corresponding weight.  <a href="#gaf7318ddaeea193a759de6349554ec3a4"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="enum-members"></a>
Enumerations</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Animation.html#ga9046e6e0d12c46c57a9056987e9d158e">Ogre::VertexAnimationType</a> { <a class="el" href="group__Animation.html#gga9046e6e0d12c46c57a9056987e9d158eab1a15dd49cf588c9b4d29e96511dc91a">Ogre::VAT_NONE</a> =  0, 
<a class="el" href="group__Animation.html#gga9046e6e0d12c46c57a9056987e9d158ea16f039e4ae5cfb19ecd7cd41be4f93cd">Ogre::VAT_MORPH</a> =  1, 
<a class="el" href="group__Animation.html#gga9046e6e0d12c46c57a9056987e9d158ea66715a5b810eee81efa1d964700b3d30">Ogre::VAT_POSE</a> =  2
 }</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Type of vertex animation.  <a href="group__Animation.html#ga9046e6e0d12c46c57a9056987e9d158e">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Animation.html#ga230b218164ffe5e6ee8970bef57e6abd">Ogre::SkeletonAnimationBlendMode</a> { <a class="el" href="group__Animation.html#gga230b218164ffe5e6ee8970bef57e6abda4d13dab20a3642f5fc20cf2bec22c2c3">Ogre::ANIMBLEND_AVERAGE</a> =  0, 
<a class="el" href="group__Animation.html#gga230b218164ffe5e6ee8970bef57e6abda5628f84206e4555c948422d2e62b7793">Ogre::ANIMBLEND_CUMULATIVE</a> =  1
 }</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Animation.html#ga5b37bdf2f67384dbd81643164545f7bd">Ogre::SkeletonChunkID</a> { <br/>
&#160;&#160;<a class="el" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bda7ed2511945645204fe9f7423e32aea49">Ogre::SKELETON_HEADER</a> =  0x1000, 
<a class="el" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bdad777591f3958da3716318eb820bbcab8">Ogre::SKELETON_BLENDMODE</a> =  0x1010, 
<a class="el" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bdaacf798731cab07af608a45eb331faa01">Ogre::SKELETON_BONE</a> =  0x2000, 
<a class="el" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bda60d951d9cd1e76668758a78eaa75e3af">Ogre::SKELETON_BONE_PARENT</a> =  0x3000, 
<br/>
&#160;&#160;<a class="el" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bdaa559ee7367718e8c9ffdfd1af83c9ca8">Ogre::SKELETON_ANIMATION</a> =  0x4000, 
<a class="el" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bdaedacebfaa34fe1ed9b95efb6210e13e1">Ogre::SKELETON_ANIMATION_BASEINFO</a> =  0x4010, 
<a class="el" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bda691013153a33fde3a543deed39382c20">Ogre::SKELETON_ANIMATION_TRACK</a> =  0x4100, 
<a class="el" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bdaebf5354fd4093986740b6f7a0b9c998e">Ogre::SKELETON_ANIMATION_TRACK_KEYFRAME</a> =  0x4110, 
<br/>
&#160;&#160;<a class="el" href="group__Animation.html#gga5b37bdf2f67384dbd81643164545f7bda869ed880064984ab52e95a922efec6cd">Ogre::SKELETON_ANIMATION_LINK</a> =  0x5000
<br/>
 }</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Definition of the OGRE .skeleton file format.  <a href="group__Animation.html#ga5b37bdf2f67384dbd81643164545f7bd">More...</a><br/></td></tr>
</table>
<hr/><h2>Define Documentation</h2>
<a class="anchor" id="ga4393e2afffe021cb323b896779de3d17"></a><!-- doxytag: member="OgreSkeleton.h::OGRE_MAX_NUM_BONES" ref="ga4393e2afffe021cb323b896779de3d17" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Animation.html#ga4393e2afffe021cb323b896779de3d17">OGRE_MAX_NUM_BONES</a>&#160;&#160;&#160;256</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSkeleton_8h_source.html#l00056">56</a> of file <a class="el" href="OgreSkeleton_8h_source.html">OgreSkeleton.h</a>.</p>

</div>
</div>
<hr/><h2>Typedef Documentation</h2>
<a class="anchor" id="ga5e0882c3b9f7ca32a795f98cf034e428"></a><!-- doxytag: member="Ogre::AnimableValuePtr" ref="ga5e0882c3b9f7ca32a795f98cf034e428" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef SharedPtr&lt;AnimableValue&gt; <a class="el" href="group__Animation.html#ga5e0882c3b9f7ca32a795f98cf034e428">Ogre::AnimableValuePtr</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAnimable_8h_source.html#l00230">230</a> of file <a class="el" href="OgreAnimable_8h_source.html">OgreAnimable.h</a>.</p>

</div>
</div>
<a class="anchor" id="gac427736c80940f4469fe0f4ac1694f67"></a><!-- doxytag: member="Ogre::AnimationStateIterator" ref="gac427736c80940f4469fe0f4ac1694f67" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef MapIterator&lt;AnimationStateMap&gt; <a class="el" href="group__Animation.html#gac427736c80940f4469fe0f4ac1694f67">Ogre::AnimationStateIterator</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAnimationState_8h_source.html#l00186">186</a> of file <a class="el" href="OgreAnimationState_8h_source.html">OgreAnimationState.h</a>.</p>

</div>
</div>
<a class="anchor" id="ga2fd1388ea690fecefc6bfe496d13e19f"></a><!-- doxytag: member="Ogre::AnimationStateMap" ref="ga2fd1388ea690fecefc6bfe496d13e19f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef map&lt;String, AnimationState*&gt;::type <a class="el" href="group__Animation.html#ga2fd1388ea690fecefc6bfe496d13e19f">Ogre::AnimationStateMap</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAnimationState_8h_source.html#l00185">185</a> of file <a class="el" href="OgreAnimationState_8h_source.html">OgreAnimationState.h</a>.</p>

</div>
</div>
<a class="anchor" id="gaad9cc8241f80d9d8fb4f112409de792f"></a><!-- doxytag: member="Ogre::ConstAnimationStateIterator" ref="gaad9cc8241f80d9d8fb4f112409de792f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef ConstMapIterator&lt;AnimationStateMap&gt; <a class="el" href="group__Animation.html#gaad9cc8241f80d9d8fb4f112409de792f">Ogre::ConstAnimationStateIterator</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAnimationState_8h_source.html#l00187">187</a> of file <a class="el" href="OgreAnimationState_8h_source.html">OgreAnimationState.h</a>.</p>

</div>
</div>
<a class="anchor" id="ga7bc761681d8c97c449763d8b77dcedf8"></a><!-- doxytag: member="Ogre::ConstEnabledAnimationStateIterator" ref="ga7bc761681d8c97c449763d8b77dcedf8" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef ConstVectorIterator&lt;EnabledAnimationStateList&gt; <a class="el" href="group__Animation.html#ga7bc761681d8c97c449763d8b77dcedf8">Ogre::ConstEnabledAnimationStateIterator</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAnimationState_8h_source.html#l00190">190</a> of file <a class="el" href="OgreAnimationState_8h_source.html">OgreAnimationState.h</a>.</p>

</div>
</div>
<a class="anchor" id="ga7f7651abe4d9e073cfdbcafd79da3511"></a><!-- doxytag: member="Ogre::EnabledAnimationStateList" ref="ga7f7651abe4d9e073cfdbcafd79da3511" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef list&lt;AnimationState*&gt;::type <a class="el" href="group__Animation.html#ga7f7651abe4d9e073cfdbcafd79da3511">Ogre::EnabledAnimationStateList</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAnimationState_8h_source.html#l00189">189</a> of file <a class="el" href="OgreAnimationState_8h_source.html">OgreAnimationState.h</a>.</p>

</div>
</div>
<a class="anchor" id="ga2320179c7d0107995d8a737c86a40333"></a><!-- doxytag: member="Ogre::PoseList" ref="ga2320179c7d0107995d8a737c86a40333" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef vector&lt;Pose*&gt;::type <a class="el" href="group__Animation.html#ga2320179c7d0107995d8a737c86a40333">Ogre::PoseList</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgrePose_8h_source.html#l00134">134</a> of file <a class="el" href="OgrePose_8h_source.html">OgrePose.h</a>.</p>

</div>
</div>
<a class="anchor" id="gaf7318ddaeea193a759de6349554ec3a4"></a><!-- doxytag: member="Ogre::VertexBoneAssignment" ref="gaf7318ddaeea193a759de6349554ec3a4" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct <a class="el" href="structOgre_1_1VertexBoneAssignment__s.html">Ogre::VertexBoneAssignment_s</a>  <a class="el" href="group__Animation.html#gaf7318ddaeea193a759de6349554ec3a4">Ogre::VertexBoneAssignment</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Records the assignment of a single vertex to a single bone with the corresponding weight. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This simple struct simply holds a vertex index, bone index and weight representing the assignment of a vertex to a bone for skeletal animation. There may be many of these per vertex if blended vertex assignments are allowed. </dd></dl>

</div>
</div>
<hr/><h2>Enumeration Type Documentation</h2>
<a class="anchor" id="ga230b218164ffe5e6ee8970bef57e6abd"></a><!-- doxytag: member="Ogre::SkeletonAnimationBlendMode" ref="ga230b218164ffe5e6ee8970bef57e6abd" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="group__Animation.html#ga230b218164ffe5e6ee8970bef57e6abd">Ogre::SkeletonAnimationBlendMode</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl><dt><b>Enumerator: </b></dt><dd><table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" id="gga230b218164ffe5e6ee8970bef57e6abda4d13dab20a3642f5fc20cf2bec22c2c3"></a><!-- doxytag: member="ANIMBLEND_AVERAGE" ref="gga230b218164ffe5e6ee8970bef57e6abda4d13dab20a3642f5fc20cf2bec22c2c3" args="" -->ANIMBLEND_AVERAGE</em>&nbsp;</td><td>
<p>Animations are applied by calculating a weighted average of all animations. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga230b218164ffe5e6ee8970bef57e6abda5628f84206e4555c948422d2e62b7793"></a><!-- doxytag: member="ANIMBLEND_CUMULATIVE" ref="gga230b218164ffe5e6ee8970bef57e6abda5628f84206e4555c948422d2e62b7793" args="" -->ANIMBLEND_CUMULATIVE</em>&nbsp;</td><td>
<p>Animations are applied by calculating a weighted cumulative total. </p>
</td></tr>
</table>
</dd>
</dl>

<p>Definition at line <a class="el" href="OgreSkeleton_8h_source.html#l00049">49</a> of file <a class="el" href="OgreSkeleton_8h_source.html">OgreSkeleton.h</a>.</p>

</div>
</div>
<a class="anchor" id="ga5b37bdf2f67384dbd81643164545f7bd"></a><!-- doxytag: member="Ogre::SkeletonChunkID" ref="ga5b37bdf2f67384dbd81643164545f7bd" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="group__Animation.html#ga5b37bdf2f67384dbd81643164545f7bd">Ogre::SkeletonChunkID</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition of the OGRE .skeleton file format. </p>
<p>.skeleton files are binary files (for read efficiency at runtime) and are arranged into chunks of data, very like 3D Studio's format. A chunk always consists of: unsigned short CHUNK_ID : one of the following chunk ids identifying the chunk unsigned long LENGTH : length of the chunk in bytes, including this header void* DATA : the data, which may contain other sub-chunks (various data types)</p>
<p>A .skeleton file contains both the definition of the <a class="el" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a> object and the animations it contains. It contains only a single skeleton but can contain multiple animations. </p>
<dl><dt><b>Enumerator: </b></dt><dd><table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" id="gga5b37bdf2f67384dbd81643164545f7bda7ed2511945645204fe9f7423e32aea49"></a><!-- doxytag: member="SKELETON_HEADER" ref="gga5b37bdf2f67384dbd81643164545f7bda7ed2511945645204fe9f7423e32aea49" args="" -->SKELETON_HEADER</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga5b37bdf2f67384dbd81643164545f7bdad777591f3958da3716318eb820bbcab8"></a><!-- doxytag: member="SKELETON_BLENDMODE" ref="gga5b37bdf2f67384dbd81643164545f7bdad777591f3958da3716318eb820bbcab8" args="" -->SKELETON_BLENDMODE</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga5b37bdf2f67384dbd81643164545f7bdaacf798731cab07af608a45eb331faa01"></a><!-- doxytag: member="SKELETON_BONE" ref="gga5b37bdf2f67384dbd81643164545f7bdaacf798731cab07af608a45eb331faa01" args="" -->SKELETON_BONE</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga5b37bdf2f67384dbd81643164545f7bda60d951d9cd1e76668758a78eaa75e3af"></a><!-- doxytag: member="SKELETON_BONE_PARENT" ref="gga5b37bdf2f67384dbd81643164545f7bda60d951d9cd1e76668758a78eaa75e3af" args="" -->SKELETON_BONE_PARENT</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga5b37bdf2f67384dbd81643164545f7bdaa559ee7367718e8c9ffdfd1af83c9ca8"></a><!-- doxytag: member="SKELETON_ANIMATION" ref="gga5b37bdf2f67384dbd81643164545f7bdaa559ee7367718e8c9ffdfd1af83c9ca8" args="" -->SKELETON_ANIMATION</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga5b37bdf2f67384dbd81643164545f7bdaedacebfaa34fe1ed9b95efb6210e13e1"></a><!-- doxytag: member="SKELETON_ANIMATION_BASEINFO" ref="gga5b37bdf2f67384dbd81643164545f7bdaedacebfaa34fe1ed9b95efb6210e13e1" args="" -->SKELETON_ANIMATION_BASEINFO</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga5b37bdf2f67384dbd81643164545f7bda691013153a33fde3a543deed39382c20"></a><!-- doxytag: member="SKELETON_ANIMATION_TRACK" ref="gga5b37bdf2f67384dbd81643164545f7bda691013153a33fde3a543deed39382c20" args="" -->SKELETON_ANIMATION_TRACK</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga5b37bdf2f67384dbd81643164545f7bdaebf5354fd4093986740b6f7a0b9c998e"></a><!-- doxytag: member="SKELETON_ANIMATION_TRACK_KEYFRAME" ref="gga5b37bdf2f67384dbd81643164545f7bdaebf5354fd4093986740b6f7a0b9c998e" args="" -->SKELETON_ANIMATION_TRACK_KEYFRAME</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga5b37bdf2f67384dbd81643164545f7bda869ed880064984ab52e95a922efec6cd"></a><!-- doxytag: member="SKELETON_ANIMATION_LINK" ref="gga5b37bdf2f67384dbd81643164545f7bda869ed880064984ab52e95a922efec6cd" args="" -->SKELETON_ANIMATION_LINK</em>&nbsp;</td><td>
</td></tr>
</table>
</dd>
</dl>

<p>Definition at line <a class="el" href="OgreSkeletonFileFormat_8h_source.html#l00055">55</a> of file <a class="el" href="OgreSkeletonFileFormat_8h_source.html">OgreSkeletonFileFormat.h</a>.</p>

</div>
</div>
<a class="anchor" id="ga9046e6e0d12c46c57a9056987e9d158e"></a><!-- doxytag: member="Ogre::VertexAnimationType" ref="ga9046e6e0d12c46c57a9056987e9d158e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="group__Animation.html#ga9046e6e0d12c46c57a9056987e9d158e">Ogre::VertexAnimationType</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Type of vertex animation. </p>
<p>Vertex animation comes in 2 types, morph and pose. The reason for the 2 types is that we have 2 different potential goals - to encapsulate a complete, flowing morph animation with multiple keyframes (a typical animation, but implemented by having snapshots of the vertex data at each keyframe), or to represent a single pose change, for example a facial expression. Whilst both could in fact be implemented using the same system, we choose to separate them since the requirements and limitations of each are quite different. </p>
<dl class="user"><dt><b></b></dt><dd>Morph animation is a simple approach where we have a whole series of snapshots of vertex data which must be interpolated, e.g. a running animation implemented as morph targets. Because this is based on simple snapshots, it's quite fast to use when animating an entire mesh because it's a simple linear change between keyframes. However, this simplistic approach does not support blending between multiple morph animations. If you need animation blending, you are advised to use skeletal animation for full-mesh animation, and pose animation for animation of subsets of meshes or where skeletal animation doesn't fit - for example facial animation. For animating in a vertex shader, morph animation is quite simple and just requires the 2 vertex buffers (one the original position buffer) of absolute position data, and an interpolation factor. Each track in a morph animation references a unique set of vertex data. </dd></dl>
<dl class="user"><dt><b></b></dt><dd><a class="el" href="classOgre_1_1Pose.html" title="A pose is a linked set of vertex offsets applying to one set of vertex data.">Pose</a> animation is more complex. Like morph animation each track references a single unique set of vertex data, but unlike morph animation, each keyframe references 1 or more 'poses', each with an influence level. A pose is a series of offsets to the base vertex data, and may be sparse - ie it may not reference every vertex. Because they're offsets, they can be blended - both within a track and between animations. This set of features is very well suited to facial animation. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>For example, let's say you modelled a face (one set of vertex data), and defined a set of poses which represented the various phonetic positions of the face. You could then define an animation called 'SayHello', containing a single track which referenced the face vertex data, and which included a series of keyframes, each of which referenced one or more of the facial positions at different influence levels - the combination of which over time made the face form the shapes required to say the word 'hello'. Since the poses are only stored once, but can be referenced may times in many animations, this is a very powerful way to build up a speech system. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>The downside of pose animation is that it can be more difficult to set up. Also, since it uses more buffers (one for the base data, and one for each active pose), if you're animating in hardware using vertex shaders you need to keep an eye on how many poses you're blending at once. You define a maximum supported number in your vertex program definition, see the includes_pose_animation material script entry. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>So, by partitioning the vertex animation approaches into 2, we keep the simple morph technique easy to use, whilst still allowing all the powerful techniques to be used. Note that morph animation cannot be blended with other types of vertex animation (pose animation or other morph animation); pose animation can be blended with other pose animation though, and both types can be combined with skeletal animation. Also note that all morph animation can be expressed as pose animation, but not vice versa. </dd></dl>
<dl><dt><b>Enumerator: </b></dt><dd><table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" id="gga9046e6e0d12c46c57a9056987e9d158eab1a15dd49cf588c9b4d29e96511dc91a"></a><!-- doxytag: member="VAT_NONE" ref="gga9046e6e0d12c46c57a9056987e9d158eab1a15dd49cf588c9b4d29e96511dc91a" args="" -->VAT_NONE</em>&nbsp;</td><td>
<p>No animation. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga9046e6e0d12c46c57a9056987e9d158ea16f039e4ae5cfb19ecd7cd41be4f93cd"></a><!-- doxytag: member="VAT_MORPH" ref="gga9046e6e0d12c46c57a9056987e9d158ea16f039e4ae5cfb19ecd7cd41be4f93cd" args="" -->VAT_MORPH</em>&nbsp;</td><td>
<p>Morph animation is made up of many interpolated snapshot keyframes. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga9046e6e0d12c46c57a9056987e9d158ea66715a5b810eee81efa1d964700b3d30"></a><!-- doxytag: member="VAT_POSE" ref="gga9046e6e0d12c46c57a9056987e9d158ea66715a5b810eee81efa1d964700b3d30" args="" -->VAT_POSE</em>&nbsp;</td><td>
<p><a class="el" href="classOgre_1_1Pose.html" title="A pose is a linked set of vertex offsets applying to one set of vertex data.">Pose</a> animation is made up of a single delta pose keyframe. </p>
</td></tr>
</table>
</dd>
</dl>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h_source.html#l00466">466</a> of file <a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:53
</p>
</body>
</html>
